using System;
using System.Collections.Generic;
using System.Text;

/*
 * sOsztly (ososztaly.cs s ososztaly2.cs):
 * - abstract, partial (abstract - nem megvalstott metdust is tartalmazhat -> nem pldnyosthat; partial - tbb forrsllomnyban specifiklt s implementlt osztly)
 * - Specifikci:
 *      protected static int; (static - osztlyszint)
 *      private string;
 *      public string (property);
 *      protected sosztly(string); (nem pldnyosthat - protected konstruktor)
 *      public static string milyenNapVan();
 *      protected abstract string szovegKerites(); (abstract - nem megvalstott metdus)
 *      public virtual void konkatMaiNap(); (virtual - felldefinilst (opertor tlterhelst/polimorfizmust) tmogat metdus
 * 
 * SzrmaztatottOsztly (szarmaztatottosztaly.cs):
 * - sealed, inherited (sealed - nem szrmaztathat; inherited - sOsztlybl szrmaztatott osztly)
 * - Specifikci:
 *      public SzrmaztatottOsztly()
            : base(string); (szrmaztatott osztly pldnyostshoz sajt konstruktorral kell rendelkeznie, a base utasts segtsgvel pldnyosthat a szrmaztatotton bell az sosztlya, ennek hinyban a base() az alaprtelmezett
 *      protected sealed override string szovegKerites(); (sealed - nem felldefinilhat; override - az sosztlyban absztrakt metdus /fell/definilsa /megj.: ktelez feltntetni, br indokolatlannak tnik, hiszen az sosztly nem valstotta meg/)
 *      public sealed override void konkatMaiNap(); (override - az sosztly megfelel specifikcij metdusnak tlterhelse)
 *      public static int (property); (readonly property - csak a get metdusa lett implementlva, a set nem)
 */

namespace osztaly
{
    class Program
    {
        static void Main(string[] args)
        {
            System.Console.WriteLine("Ksztnk egy partial class absztrakt sosztlyt, amelynek egy static int -et s egy string -et s egy megvalstott static metdust, egy megvalstatlan metdust, egy virtulis megvalstott metdust s egy property -t tartalmaz. Konstruktora paramterbl kapott rtket ad a string -nek. Szrmaztatunk belle egy sealed osztlyt, amely konkrt rtkkel pldnyostja az st, a virtulis mvelett overrideolja, a megvalstatlant implementlja s hozzvesz egy j readonly property -t. Az j osztly lehetv teszi, hogy lekrdezzk azt, hogy sszesen hny pldny kszlt belle!");
            System.Console.Write(System.Environment.NewLine + "Ltrehozunk vletlenszm ([1,1000]) SzrmaztatottOsztly pldnyt s vgl az osztly segtsgvel kiiratjuk, hogy hnyat hoztunk ltre: ");
            System.Random rand = new System.Random();
            SzrmaztatottOsztly[] tomb = new SzrmaztatottOsztly[rand.Next(1, 1000)];
            for (int i = 0; i < tomb.Length; ++i)
                tomb[i] = new SzrmaztatottOsztly();
            System.Console.WriteLine(SzrmaztatottOsztly.Counter);
            tomb[0].konkatMaiNap();
            System.Console.Write(System.Environment.NewLine+"Ezen kvl azt is megtudhatjuk az osztlytl, hogy milyen nap van: {0}, valamint a ltrehozott pldnyok kzl brmelyiktl (mi most az elstl) megkrdezhetjk, hogy ezt hogy kell szpen mondani: \"{1}\"",SzrmaztatottOsztly.milyenNapVan(),tomb[0].Szoveg);
            System.Console.ReadKey(true);
        }
    }
}
